*
      PROGRAM  TCL_SYEV1N
*
      include 'mpif.h'
*
      INTEGER            CTXT, N, NPROW, NPCOL, NB, NPRT, MEMSIZE,
     $                   NOUT1, NOUT, NPR, IL, IU
      PARAMETER          ( N=7000, NB=254, MEMSIZE= 7300000, NPRT= 1 )
*
      DOUBLE PRECISION   AMEM( MEMSIZE ), VL, VU, ABSTOL
      CHARACTER*(*)      NAME, UPLO
      CHARACTER          INFILEA*(*), OUTFILE*(*), TFILE*(*)
      PARAMETER         ( NOUT1 = 12, NOUT =13, NPR = 6 )
      PARAMETER         ( INFILEA = '  ', INFILEB = '  ',
     $                    OUTFILE = 'cal_syev1n.res',
     $                    TFILE = 'cal_syev1n.tres')
*
      PARAMETER         ( UPLO = 'U', NAME = 'PDSYEV1')
      DOUBLE PRECISION    time
      COMMON            time, J
      EXTERNAL         CAL_SYEV1N, BLACS_GET, BLACS_GRIDINIT,
     $                 BLACS_GRIDINFO
*
      NPROW = 2
      NPCOL = 4
*
      VL = 0.D0
      VU = 0.D0
      IL = 0
      IU = 0
      ABSTOL = 0.D0
*
      J = 1
*
      CALL BLACS_GET( -1, 0, CTXT )
*
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
*
*       
*
         OPEN( NOUT1, FILE = TFILE, STATUS = 'UNKNOWN' )
*      ,
*  ,     
*
         WRITE( NOUT1, FMT = 2007 ) NAME, N, NPROW*NPCOL, NB
*
      END IF
*
      CALL CAL_SYEV1N(NAME, UPLO, N, NPROW, NPCOL, AMEM, MEMSIZE, NB,
     $               VL, VU, IL, IU, ABSTOL, INFILEA, OUTFILE, TFILE,
     $               NPRT, CTXT)
*
*      
*  ,    
*
   32   IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
          WRITE( NPR, FMT = 2001 ) NPROW, NPCOL, NB, time
*
*      
*  ,    
*
         WRITE( NOUT1, FMT = 2001 ) NPROW, NPCOL, NB, time
*
        END IF
*
*     
      CLOSE( NOUT1 )
*
      CALL BLACS_GRIDEXIT( CTXT )
*   BLACS'
      CALL BLACS_EXIT( 0 )
*
 2007 FORMAT( /A8,'  N = ',I5,'   NPROCS = ',I3,'  NB = ',I3/)
 2001 FORMAT( '    (',I3,','I3,
     $        ' )   NB = ', I3, D14.3/ )
*
      STOP
      END
